/**
 * SDRangel
 * This is the web REST/JSON API of SDRangel SDR software. SDRangel is an Open Source Qt5/OpenGL 3.0+ (4.3+ in Windows) GUI and server Software Defined Radio and signal analyzer in software. It supports Airspy, BladeRF, HackRF, LimeSDR, PlutoSDR, RTL-SDR, SDRplay RSP1 and FunCube    ---   Limitations and specifcities:    * In SDRangel GUI the first Rx device set cannot be deleted. Conversely the server starts with no device sets and its number of device sets can be reduced to zero by as many calls as necessary to /sdrangel/deviceset with DELETE method.   * Preset import and export from/to file is a server only feature.   * Device set focus is a GUI only feature.   * The following channels are not implemented (status 501 is returned): ATV and DATV demodulators, Channel Analyzer NG, LoRa demodulator   * The device settings and report structures contains only the sub-structure corresponding to the device type. The DeviceSettings and DeviceReport structures documented here shows all of them but only one will be or should be present at a time   * The channel settings and report structures contains only the sub-structure corresponding to the channel type. The ChannelSettings and ChannelReport structures documented here shows all of them but only one will be or should be present at a time    --- 
 *
 * OpenAPI spec version: 7.0.0
 * Contact: f4exb06@gmail.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


#include "SWGFreqScannerChannelState.h"

#include "SWGHelpers.h"

#include <QJsonDocument>
#include <QJsonArray>
#include <QObject>
#include <QDebug>

namespace SWGSDRangel {

SWGFreqScannerChannelState::SWGFreqScannerChannelState(QString* json) {
    init();
    this->fromJson(*json);
}

SWGFreqScannerChannelState::SWGFreqScannerChannelState() {
    frequency = 0;
    m_frequency_isSet = false;
    power = 0.0f;
    m_power_isSet = false;
}

SWGFreqScannerChannelState::~SWGFreqScannerChannelState() {
    this->cleanup();
}

void
SWGFreqScannerChannelState::init() {
    frequency = 0;
    m_frequency_isSet = false;
    power = 0.0f;
    m_power_isSet = false;
}

void
SWGFreqScannerChannelState::cleanup() {


}

SWGFreqScannerChannelState*
SWGFreqScannerChannelState::fromJson(QString &json) {
    QByteArray array (json.toStdString().c_str());
    QJsonDocument doc = QJsonDocument::fromJson(array);
    QJsonObject jsonObject = doc.object();
    this->fromJsonObject(jsonObject);
    return this;
}

void
SWGFreqScannerChannelState::fromJsonObject(QJsonObject &pJson) {
    ::SWGSDRangel::setValue(&frequency, pJson["frequency"], "qint32", "");
    
    ::SWGSDRangel::setValue(&power, pJson["power"], "float", "");
    
}

QString
SWGFreqScannerChannelState::asJson ()
{
    QJsonObject* obj = this->asJsonObject();

    QJsonDocument doc(*obj);
    QByteArray bytes = doc.toJson();
    delete obj;
    return QString(bytes);
}

QJsonObject*
SWGFreqScannerChannelState::asJsonObject() {
    QJsonObject* obj = new QJsonObject();
    if(m_frequency_isSet){
        obj->insert("frequency", QJsonValue(frequency));
    }
    if(m_power_isSet){
        obj->insert("power", QJsonValue(power));
    }

    return obj;
}

qint32
SWGFreqScannerChannelState::getFrequency() {
    return frequency;
}
void
SWGFreqScannerChannelState::setFrequency(qint32 frequency) {
    this->frequency = frequency;
    this->m_frequency_isSet = true;
}

float
SWGFreqScannerChannelState::getPower() {
    return power;
}
void
SWGFreqScannerChannelState::setPower(float power) {
    this->power = power;
    this->m_power_isSet = true;
}


bool
SWGFreqScannerChannelState::isSet(){
    bool isObjectUpdated = false;
    do{
        if(m_frequency_isSet){
            isObjectUpdated = true; break;
        }
        if(m_power_isSet){
            isObjectUpdated = true; break;
        }
    }while(false);
    return isObjectUpdated;
}
}

